----------------------------------------------------------------------------------------------------
-- Configuration
----------------------------------------------------------------------------------------------------

-- Time to apply the wind
local hitTime = 0.25

-- Multiplier for player speed
local speedMultiplier = 60

----------------------------------------------------------------------------------------------------
-- Code
----------------------------------------------------------------------------------------------------

local playerId

local function onRaceInit()
	local player = scenetree.findObject('scenario_player0')
	playerId = player.obj:getID()
end

local function onVehicleCollision(left, right)
	local other
	
	if left == playerId then
		other = right
	elseif right == playerId then
		other = left
	else
		return
	end
	
	local playerData = map.objects.player
	local otherObject = scenetree.findObject(other)
	
	if not playerData or not otherObject then
		return
	end
	
	local direction = playerData.vel * speedMultiplier
	
	local windCommand = 'obj:setWind('..direction.x ..','..direction.y ..','..direction.z..')'
	otherObject:queueLuaCommand(windCommand)
	
	local gravityCommand = 'obj:setGravity(-2)'
	otherObject:queueLuaCommand(gravityCommand)
	
	local endWind = function()
		otherObject:queueLuaCommand('obj:setWind(0, 0, 0)')
		otherObject:queueLuaCommand('obj:setGravity(-9.81)')
	end
	
	local windTimer = bnse.timers.create(hitTime, { onEnd = endWind })
	windTimer:start()
end


----------------------------------------------------------------------------------------------------
-- Interface
----------------------------------------------------------------------------------------------------

return {
	onRaceInit = onRaceInit,
	onVehicleCollision = onVehicleCollision
}