--------------------------------------------------------------------------------
-- Demo Derby Vehicle Randomiser
-- By Dagalufh & Scepheo
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Scenario config
--------------------------------------------------------------------------------

local vehicleNames = 
{
	"scenario_player0",
	"opponent1",
	"opponent2",
	"opponent3",
}

--------------------------------------------------------------------------------
-- Scenario code
--------------------------------------------------------------------------------

local function onScenarioChange(scenario)
	scenario.demoNames = {}
	
	if scenario and scenario.state == 'pre-start' then
		for i, name in pairs(vehicleNames) do
			local config = bnse.randomize.vehicle(name)
			scenario.demoNames[i - 1] = config.Name
		end
	end
end

local function onPhysicsEngineEvent(eventType)
	-- Freeze whenever a vehicle is spawned or despawned
	scenetree.scenario_player0:queueLuaCommand('scenario.freeze(1)')
end

return {
	onScenarioChange = onScenarioChange,
	onPhysicsEngineEvent = onPhysicsEngineEvent
}